#!/usr/bin/python3
# THRANSOFT: Simple QOTD Server Release 1
# SRC: https://superuser.com/questions/567560/how-to-make-a-qotd-server-or-similar
# See also: RFC 865
# Thran 25 04 2019 S.D.G.
from socket import *
import sys

# global vars really bit me in this one; I'm sure there's a better way
# boy do I prefer the C handling of scope
global host, port, currentQotd, maxQotd, openedQuotes
host = ''
port = 17
currentQotd = 0
maxQotd = 1
openedQuotes = list()

def readFile(path):
    openedFile = open(path)
    global openedQuotes
    for quote in openedFile:
        openedQuotes.append(quote)
    openedFile.close()

# if args are called open the file, return a different quote each time this is called. Each quote is one line from the file.
def openQuoteFile():
    if len(sys.argv) > 1:
        print("Importing QOTDs from:", sys.argv[1])
        readFile(sys.argv[1])
    else:
        global openedQuotes
        openedQuotes = ["It's a fine day for anything."]


    global maxQotd
    maxQotd = len(openedQuotes)
    print("Successfully opened %d quotes!" % maxQotd)

def getNextQOTD():
    global currentQotd, maxQotd
    if currentQotd == maxQotd-1:
        currentQotd = 0
        return str(openedQuotes[currentQotd])
    else:
        currentQotd += 1
        return str(openedQuotes[currentQotd])


print("Starting up QOTD server...")
openQuoteFile()

qotdSock = socket(AF_INET, SOCK_STREAM)
qotdSock.bind((host,port))
qotdSock.listen(5)

print("Running and awaiting connection.")

while 1:
    try:
        connection, address = qotdSock.accept()
        print("Connection made from:", address, end=' ')
        msg = getNextQOTD()
        print ("Sharing quote:", msg)
        connection.send(msg.encode())
        connection.close()
    except KeyboardInterrupt:
        print("Shutting down server...")
        break

# ref for interrupt: https://stackoverflow.com/questions/22183115/how-to-break-this-loop-in-python-by-detecting-key-press
